#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <signal.h>
#include <netinet/ip.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>



#define INVNT 100
#define BCAST 200
#define PRNTO 300


struct InvDados
{
	char Kernel[100];
	char CPU[100];
	char MemTotal[100];
	char MemLivre[100];
	
	int sizeKernel;
	int sizeCPU;	
	int sizeMemTotal;
	int sizeMemLivre;
};

int VerificarBroadcastUDP(int SocketBcast, char *IP)
{
	int bytes = 0, sizeADM, sizeComando, Comando;
	struct sockaddr_in ADM;
	printf("Verificando BCAST...\n");

        sizeADM = sizeof(ADM);
	sizeComando = sizeof(Comando);
        bytes = recvfrom(SocketBcast,&Comando,sizeComando,MSG_DONTWAIT,(struct sockaddr*)&ADM,&sizeADM);
	
	
	alarm(5);
        if(Comando == BCAST)
	{
		strcpy(IP,inet_ntoa(ADM.sin_addr));
		alarm(0);
		printf("Bytes Bcast: %d\n",bytes);
                return 1;
	}
        else
                return 0;
	
}

int EnviarResposta(char *IPADM)
{
	int bytes = 0, sizeADM, len, sizeComando, Comando;
	struct sockaddr_in EndLocal;
	int Sockfd;
	Sockfd = socket(PF_INET,SOCK_DGRAM,0);

	
	len = sizeof(EndLocal);
	memset((struct sockaddr_in*)&(EndLocal),0,len);
        EndLocal.sin_family = PF_INET;
        EndLocal.sin_port = ntohs(9090);
        EndLocal.sin_addr.s_addr = inet_addr(IPADM);
	bind(Sockfd,(struct sockaddr *) &EndLocal,len);	

	Comando = PRNTO;
 	sizeComando = sizeof(Comando);
        bytes = sendto(Sockfd,&Comando,sizeComando,0,(struct sockaddr*)&EndLocal,len);
	printf("%d\n",bytes);
        if(Comando == BCAST)
                return 1;
        else
                return 0;
	
}


int CriarSocketBroadcastUDP(int porta)
{
	struct sockaddr_in EndLocal;
        int sockfd, len, retorno;
    	int reuse = 1;
        retorno = sockfd = socket(PF_INET, SOCK_DGRAM,0);

        len = sizeof(EndLocal);
	
	memset((struct sockaddr_in*)&(EndLocal),0,len);
        EndLocal.sin_family = AF_INET;
        EndLocal.sin_port = htons(porta);
        EndLocal.sin_addr.s_addr = inet_addr("127.255.255.255");

        setsockopt(sockfd,SOL_SOCKET,SO_REUSEADDR,&reuse,sizeof reuse);

        if((bind(sockfd,(struct sockaddr *) &EndLocal,len)) == -1)
                retorno = -1;
        if(retorno <= 0)
                close(sockfd);
        return retorno;

	
}

int CriarSocketTrafegarDadosTCP(int porta)
{
	struct sockaddr_in EndLocal;
        int sockfd, len, retorno;
    	int reuse = 1;
        retorno = sockfd = socket(AF_INET, SOCK_STREAM,0);

        len = sizeof(EndLocal);

        memset((struct sockaddr_in *)&(EndLocal),0,len);
        EndLocal.sin_family = AF_INET;
        EndLocal.sin_port = htons(porta);
        EndLocal.sin_addr.s_addr = htonl(INADDR_ANY);

        if((bind(sockfd,(struct sockaddr *) &EndLocal,len)) == -1)
                retorno = -1;
        if(listen(sockfd,5) == -1)
		retorno = -1;
	if(retorno <= 0)
                close(sockfd);
	
        return retorno;

	
}

struct InvDados ColetarDadosInventario()
{
	struct InvDados DadosInventario;
	strcpy(DadosInventario.Kernel,Kernel());
	strcpy(DadosInventario.CPU,CPU());
	strcpy(DadosInventario.MemTotal,MemTotal());
	strcpy(DadosInventario.MemLivre,MemLivre());

	DadosInventario.sizeKernel = strlen(DadosInventario.Kernel);
	DadosInventario.sizeCPU = strlen(DadosInventario.CPU);
	DadosInventario.sizeMemTotal = strlen(DadosInventario.MemTotal);
	DadosInventario.sizeMemLivre = strlen(DadosInventario.MemLivre);
	
	return DadosInventario;
}

int InstalarSinalAlarme()
{
	struct sigaction sa_old;
	struct sigaction sa_new;

        sa_new.sa_handler = (void*)VerificarBroadcastUDP;
        sigemptyset(&sa_new.sa_mask);
        sa_new.sa_flags = 0;
        sigaction(SIGALRM,&sa_new,&sa_old);
	

}


int TratarRequisicoesADM(int SocketDados, int SocketBcast)
{
	int SocketADM, sizeADM, Comando;
	char IPADM[100];
	struct sockaddr_in ADM;
	sizeADM = sizeof(ADM);
	struct InvDados DadosInventario;
	//SocketADM = 0; 
	

	while(1)
	{
		if(VerificarBroadcastUDP(SocketBcast,IPADM))
		{
			printf("Recebi BCAST\n");
			EnviarResposta(IPADM);
			alarm(5);
		}
		SocketADM = accept(SocketDados,(struct sockaddr*)&ADM,&sizeADM);
		if(SocketADM != -1)
		{
			alarm(0);
			printf("Recebi Conexao\n");
			printf("%d\n",SocketADM);
			
			recv(SocketADM,&Comando,sizeof(Comando),0);
			if(Comando == INVNT)
			{
				DadosInventario = ColetarDadosInventario();
				printf("Enviando CPU: %s - Tamanho: %d\n",DadosInventario.CPU,DadosInventario.sizeCPU);
				send(SocketADM,&DadosInventario,sizeof(DadosInventario),0);
			}
			
		}
	}
	
}

int main(int argc, char *argv[])
{
	int SocketBcast, SocketDados;
		
	SocketBcast = CriarSocketBroadcastUDP(9090);
	InstalarSinalAlarme();
	SocketDados = CriarSocketTrafegarDadosTCP(3000);
	TratarRequisicoesADM(SocketDados,SocketBcast);

}
